#include <Config.h>

#include <memory>

#include <string>
#include <fstream>

bool LoadConfig(Config &cfg, std::wstring name) {
	std::wifstream configfilehandle{};
	configfilehandle.open(name.c_str(), std::wofstream::in);

	std::wstring ll{};

	if (configfilehandle.is_open()) {
		while (!configfilehandle.eof()) {
			configfilehandle >> ll;
			if (ll.compare(L"Fullscreen:") == 0) {
				configfilehandle >> ll;
				if (_wtoi(ll.c_str()) == 0)
					cfg.FullScreen = false;
				else
					cfg.FullScreen = true;
			}
			if (ll.compare(L"Width:") == 0) {
				configfilehandle >> ll;
				cfg.Width = _wtoi(ll.c_str());

				if (cfg.Width == 0) {
					configfilehandle.close();
					return false;
				}
			}
			if (ll.compare(L"Height:") == 0) {
				configfilehandle >> ll;
				cfg.Height = _wtoi(ll.c_str());
				if (cfg.Height == 0) {
					configfilehandle.close();
					return false;
				}
			}
			if (ll.compare(L"FeatureLevel:") == 0) {
				configfilehandle >> ll;
				cfg.Feature = _wtoi(ll.c_str());
			}
			if (ll.compare(L"ScreenMode:") == 0) {
				configfilehandle >> ll;
				cfg.GraphModeNum = _wtoi(ll.c_str());
			}
		}

		configfilehandle.close();
	}
	else return false;

	return true;
}

bool SaveConfig(Config &cfg, std::wstring name) {
	std::wofstream configfilehandle{};
	configfilehandle.open(name.c_str(), std::wofstream::out);

	if (configfilehandle.is_open()) {
		configfilehandle << L"[GRAPHICS] " << L"\n\n";
		configfilehandle << L"Width: " << cfg.Width << L"\n";
		configfilehandle << L"Height: " << cfg.Height << L"\n";
		configfilehandle << L"ScreenMode: " << cfg.GraphModeNum << L"\n";
		configfilehandle << L"FeatureLevel: " << cfg.Feature << L"\n";
		configfilehandle << L"FullScreen: " << cfg.FullScreen;

		configfilehandle.close();
	}
	else return false;

	return true;
}